'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FilterActions = exports.Filter = exports.Filters = exports.FiltersContainer = exports.Label = exports.ChipsContainer = exports.Chips = exports.Chip = exports.ShowMore = exports.ApplyButton = exports.ResetButton = exports.FilterComponentContainer = undefined;

var _templateObject = _taggedTemplateLiteral(['\n    position: relative;\n    background-color: ', ';\n    box-shadow: 0 0 2px 0 ', ';\n    transition: all 0.25s ease-out;\n    max-height: 0;\n    overflow: hidden;\n    opacity: 0;\n\n    &.open {\n        transition: all 0.35s ease-in;\n        max-height: 600px;\n        opacity: 1;\n        overflow: visible;\n    }\n'], ['\n    position: relative;\n    background-color: ', ';\n    box-shadow: 0 0 2px 0 ', ';\n    transition: all 0.25s ease-out;\n    max-height: 0;\n    overflow: hidden;\n    opacity: 0;\n\n    &.open {\n        transition: all 0.35s ease-in;\n        max-height: 600px;\n        opacity: 1;\n        overflow: visible;\n    }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n    padding: 8px 20px;\n    cursor: pointer;\n    outline: none;\n'], ['\n    padding: 8px 20px;\n    cursor: pointer;\n    outline: none;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n    border: none;\n    background: none;\n    color: ', ';\n'], ['\n    border: none;\n    background: none;\n    color: ', ';\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n    background-color: ', ';\n    border: solid 1px ', ';\n    border-radius: 4px;\n    color: white;\n'], ['\n    background-color: ', ';\n    border: solid 1px ', ';\n    border-radius: 4px;\n    color: white;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n    font-size: 12px;\n    margin: 2px;\n    cursor: pointer;\n    display: inline-block;\n    color: ', ';\n'], ['\n    font-size: 12px;\n    margin: 2px;\n    cursor: pointer;\n    display: inline-block;\n    color: ', ';\n']),
    _templateObject6 = _taggedTemplateLiteral(['\n    display: inline-block;\n    background-color: ', ';\n    font-size: 12px;\n    border-radius: 12px;\n    margin: 2px;\n    padding: 4px 10px;\n    color: ', ';\n\n    span {\n        padding-right: 10px;\n    }\n\n    i {\n        cursor: pointer;\n    }\n'], ['\n    display: inline-block;\n    background-color: ', ';\n    font-size: 12px;\n    border-radius: 12px;\n    margin: 2px;\n    padding: 4px 10px;\n    color: ', ';\n\n    span {\n        padding-right: 10px;\n    }\n\n    i {\n        cursor: pointer;\n    }\n']),
    _templateObject7 = _taggedTemplateLiteral(['\n    max-height: ', ';\n    overflow: auto;\n'], ['\n    max-height: ', ';\n    overflow: auto;\n']),
    _templateObject8 = _taggedTemplateLiteral(['\n    display: flex;\n    padding: 10px 10px 0;\n    align-items: center;\n'], ['\n    display: flex;\n    padding: 10px 10px 0;\n    align-items: center;\n']),
    _templateObject9 = _taggedTemplateLiteral(['\n    white-space: nowrap;\n    padding-right: 10px;\n    font-size: 14px;\n'], ['\n    white-space: nowrap;\n    padding-right: 10px;\n    font-size: 14px;\n']),
    _templateObject10 = _taggedTemplateLiteral(['\n    display: flex;\n    justify-content: space-between;\n    flex-direction: column;\n    padding: 10px;\n'], ['\n    display: flex;\n    justify-content: space-between;\n    flex-direction: column;\n    padding: 10px;\n']),
    _templateObject11 = _taggedTemplateLiteral(['\n    display: flex;\n    flex-grow: 1;\n    flex-wrap: wrap;\n'], ['\n    display: flex;\n    flex-grow: 1;\n    flex-wrap: wrap;\n']),
    _templateObject12 = _taggedTemplateLiteral(['\n    padding: 3px;\n'], ['\n    padding: 3px;\n']),
    _templateObject13 = _taggedTemplateLiteral(['\n    display: flex;\n    align-items: flex-end;\n    padding: 5px 3px;\n'], ['\n    display: flex;\n    align-items: flex-end;\n    padding: 5px 3px;\n']);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _colorCodes = require('../../colorCodes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FilterComponentContainer = exports.FilterComponentContainer = _styledComponents2.default.div(_templateObject, _colorCodes.colors.greyBackground, _colorCodes.colors.lineBorder);
var Button = _styledComponents2.default.button(_templateObject2);
var ResetButton = exports.ResetButton = Button.extend(_templateObject3, _colorCodes.colors.greyText);
var ApplyButton = exports.ApplyButton = Button.extend(_templateObject4, _colorCodes.colors.greyBtnBackground, _colorCodes.colors.greyBorder);
var ShowMore = exports.ShowMore = _styledComponents2.default.a(_templateObject5, _colorCodes.colors.greyText);
var Chip = exports.Chip = _styledComponents2.default.div(_templateObject6, _colorCodes.colors.chipBackground, _colorCodes.colors.whiteText);
var Chips = exports.Chips = _styledComponents2.default.div(_templateObject7, function (props) {
    return props.chipsHeight || 'none';
});
var ChipsContainer = exports.ChipsContainer = _styledComponents2.default.div(_templateObject8);
var Label = exports.Label = _styledComponents2.default.span(_templateObject9);
var FiltersContainer = exports.FiltersContainer = _styledComponents2.default.div(_templateObject10);
var Filters = exports.Filters = _styledComponents2.default.div(_templateObject11);
var Filter = exports.Filter = _styledComponents2.default.div(_templateObject12);
var FilterActions = exports.FilterActions = _styledComponents2.default.div(_templateObject13);