'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Portal = function (_React$PureComponent) {
    _inherits(Portal, _React$PureComponent);

    function Portal() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Portal);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Portal.__proto__ || Object.getPrototypeOf(Portal)).call.apply(_ref, [this].concat(args))), _this), _this.getLayer = function () {
            if (!_this.layer) {
                _this.layer = document.createElement('div');
                if (document.body && _this.layer) {
                    document.body.appendChild(_this.layer);
                }
            }
            return _this.layer;
        }, _this.unrenderLayer = function () {
            if (_this.layer) {
                document.body.removeChild(_this.layer);
                _this.layer = null;
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Portal, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.renderLayer();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this.renderLayer();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.unrenderLayer();
        }

        /**
         * Returns the layer in which children will be rendered
         */


        /**
         * Removes the previously rendered layer
         */

    }, {
        key: 'renderLayer',


        /**
         * Renders the children inside the layer
         */
        value: function renderLayer() {
            var _props = this.props,
                children = _props.children,
                open = _props.open;


            if (open) {
                var layerElement = _react2.default.Children.only(children);
                _reactDom2.default.unstable_renderSubtreeIntoContainer(this, layerElement, this.getLayer());
            } else {
                this.unrenderLayer();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            return null;
        }
    }]);

    return Portal;
}(_react2.default.PureComponent);

exports.default = Portal;


Portal.propTypes = {
    children: _propTypes.PropTypes.element.isRequired,
    /**
     * Renders the children at body level
     */
    open: _propTypes.PropTypes.bool
};

Portal.defaultProps = {
    open: false
};