'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ToggleComponent = require('./styles/ToggleComponent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var ToggleComponent = function (_React$Component) {
    _inherits(ToggleComponent, _React$Component);

    function ToggleComponent(props) {
        _classCallCheck(this, ToggleComponent);

        var _this = _possibleConstructorReturn(this, (ToggleComponent.__proto__ || Object.getPrototypeOf(ToggleComponent)).call(this, props));

        _this.state = {
            show: props.default,
            disabled: props.disable
        };
        _lodash2.default.bindAll(_this, ['resetFilters', '_toggle']);
        return _this;
    }

    _createClass(ToggleComponent, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.disable !== nextProps.disable) {
                this.setState({
                    disabled: nextProps.disable
                });
            }
            if (this.props.default !== nextProps.default) {
                this.setState({
                    show: nextProps.default
                });
            }
        }
    }, {
        key: 'resetFilters',
        value: function resetFilters(event) {
            event.stopPropagation();
            this.props.resetFilters(this.props.name);
        }
    }, {
        key: '_toggle',
        value: function _toggle() {
            this.setState({
                show: !this.state.disabled && !this.state.show
            });
            if (this.props.onToggle) {
                this.props.onToggle(this.props.name);
            }
        }
    }, {
        key: 'handleClickOutside',
        value: function handleClickOutside() {
            if (this.state.show) {
                this._toggle.call(this);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var resetButton = '';
            if (this.props.activeFilter) {
                resetButton = _react2.default.createElement(_ToggleComponent.ResetButton, {
                    className: this.props.activeFilter ? 'fa fa-undo active-icon-color' : '',
                    onClick: this.resetFilters
                });
            }

            return _react2.default.createElement(
                _ToggleComponent.ToggleComponentContainer,
                { className: this.props.className },
                _react2.default.createElement(
                    'div',
                    {
                        onClick: this._toggle,
                        className: 'toggle-button ' + (this.props.openedClass || '') + '\n                    ' + (this.props.activeFilter ? ' has-filter' : '') + ' ' + (this.props.activeStatus ? 'active' : '')
                    },
                    resetButton,
                    this.props.label,
                    _react2.default.createElement('span', {
                        className: 'toggle-icon fa ' + (this.state.show ? 'fa-chevron-up ' : 'fa-chevron-down ') + (this.props.activeFilter ? 'active-icon-color' : 'inprogress-icon-color')
                    })
                ),
                this.state.show && this.props.children
            );
        }
    }]);

    return ToggleComponent;
}(_react2.default.Component);

ToggleComponent.propTypes = {
    openedClass: _propTypes2.default.string,
    name: _propTypes2.default.string,
    className: _propTypes2.default.string,
    disable: _propTypes2.default.bool,
    label: _propTypes2.default.string,
    default: _propTypes2.default.node,
    resetFilters: _propTypes2.default.func,
    onToggle: _propTypes2.default.func,
    activeFilter: _propTypes2.default.string,
    children: _propTypes2.default.node.isRequired,
    activeStatus: _propTypes2.default.bool
};

ToggleComponent.defaultProps = {
    default: false,
    disable: false,
    activeStatus: false,
    className: '',
    label: '',
    openedClass: '',
    name: '',
    resetFilters: function resetFilters(f) {
        return f;
    },
    onToggle: function onToggle(f) {
        return f;
    },
    activeFilter: ''
};

exports.default = (0, _reactClickOutside2.default)(ToggleComponent);